<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Блок "Список объявлений".
 *
 * <a href="http://wiki.a-cms.ru/blocks/board">Руководство</a>.
 */

class board_Block extends A_Block
{
/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	if($this->params['sort']!=4)
	$this->supportCached();

	$this->params['idcat']=(integer)$this->params['idcat'];
	$this->params['rows']=(integer)$this->params['rows'];

	if($this->params['idcat'])
	{ $catrow=A::$DB->getRowById($this->params['idcat'],"{$this->section}_categories");
	  $catrow['link']=board_createCategoryLink($this->params['idcat'],$this->section);
	  $this->Assign("category",$catrow);
	}

	switch($this->params['sort'])
	{ default:
	  case 1: $sort="date DESC"; break;
	  case 2: $sort="date"; break;
	  case 3: $sort="name"; break;
	  case 4: $sort="RAND()"; break;
	}

	if($this->params['idcat'])
	{ $idcats=array($this->params['idcat']);
	  getTreeSubItems("{$this->section}_categories",$this->params['idcat'],$idcats);
      $sql="
	  SELECT DISTINCT s.iditem AS sid,c.*
	  FROM {$this->section} AS s
	  LEFT JOIN {$this->section}_catalog AS c ON c.id=s.iditem
	  WHERE s.idcat IN(".implode(",",$idcats).") AND c.active='Y'
	  ORDER BY $sort";
	}
	else
	$sql="SELECT * FROM {$this->section}_catalog WHERE active='Y' ORDER BY $sort";

	if($this->params['rows'])
	A::$DB->queryLimit($sql,0,$this->params['rows']);
	else
	A::$DB->query($sql);

	$items=array();
    while($row=A::$DB->fetchRow())
    { $row['link']=board_createItemLink($row['id'],$this->section);
      $row['categories']=array();
	  if($idcats=A::$DB->getCol("SELECT DISTINCT idcat FROM {$this->section} WHERE iditem={$row['id']} ORDER BY id"))
      foreach($idcats as $idcat)
	  $row['categories'][]=array('name'=>getTreePath("{$this->section}_categories",$idcat),'link'=>board_createCategoryLink($idcat,$this->section));
	  if($this->options['useimages'])
	  { $row['images']=A::$DB->getAll("SELECT * FROM ".DOMAIN."_images WHERE idsec=? AND iditem=? ORDER BY sort",array($this->section_id,$row['id']));
	    $row['idimg']=isset($row['images'][0]['id'])?$row['images'][0]['id']:0;
	  }
	  prepareValues($this->section,$row);
	  $row=A::$OBSERVER->Modifier('board_prepareValues',$this->section,$row);
      $items[]=$row;
    }
    A::$DB->free();

	$this->Assign("items",$items);
  }
}